import greenfoot.*;
import java.util.Calendar;
/**
 * Write a description of class WORLD_GENERATOR here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class WORLD_GENERATOR extends Actor
{
    boolean generated = false;
    int surface = 420, nextDown, nextUp;
    int max_right = 3000, max_left = -3000;

    protected void addedToWorld(World world)
    {
        setLocation(-3000, 800);
    }

    void generate()
    {
        int i = 0;

        Greenfoot.setSpeed(100);
        getWorld().addObject(new ground(1, true), getX(), surface);
        for(i=surface+20; i<getY(); i+=20)
        {
            getWorld().addObject(new ground(2, true), getX(), i);
        }
        switch(Greenfoot.getRandomNumber(30)) //ADD FLORA
        {
            case 1: getWorld().addObject(new ground(5, false), getX(), surface-20); break;
            case 2: getWorld().addObject(new ground(6, false), getX(), surface-20); break;
            case 3: getWorld().addObject(new ground(7, false), getX(), surface-20); break;
            case 4: getWorld().addObject(new ground(8, false), getX(), surface-20); break;
        }
        switch(Greenfoot.getRandomNumber(30)) //ADD TREES
        {
            case 5: add_tree(surface, getX()); break;
        }
        switch(Greenfoot.getRandomNumber(4)) //MODIFY TERRAIN LEVEL
        {
            case 0: if(surface-20>-600 && nextDown>=3) { surface -= 20; nextDown=Greenfoot.getRandomNumber(6); } break;
            case 1: if(surface+20<600 && nextDown<3) { surface += 20; nextDown=Greenfoot.getRandomNumber(6); } break;
            case 2: break;
            case 3: break;
        }
        setLocation(getX()+20, getY());
        if(getX() >= 3000) { generated = true; }
    }

    public void act()
    {
        if(!generated)
        {
            generate();
        }
        else
        {
            if(getWorld().getObjects(actor.class).isEmpty()) { getWorld().addObject(new actor(), 200, 100); Greenfoot.setSpeed(50); }
            else
            {
                if(((myWorld) getWorld()).actor_x > max_right-500)
                {
                    setLocation(max_right, getY()); generate();
                    setLocation(max_left, getY());
                    for(int i = 0; i<getY(); i+=20)
                    {
                        getWorld().removeObjects(getWorld().getObjectsAt(getX(), i, ground.class));
                    }
                    max_right += 20;
                    max_left += 20;
                }
                
                if(((myWorld) getWorld()).actor_x < max_left+500)
                {
                    setLocation(max_left, getY()); generate();
                    setLocation(max_right, getY());
                    for(int i = 0; i<getY(); i+=20)
                    {
                        getWorld().removeObjects(getWorld().getObjectsAt(getX(), i, ground.class));
                    }
                    max_left -= 20;
                    max_right -= 20;
                }
            }
        }
    }

    void add_tree(int base_y, int x)
    {
        switch(Greenfoot.getRandomNumber(8))
        {
            case 0:
            getWorld().addObject(new ground(3, true), x, base_y-20);
            getWorld().addObject(new ground(3, true), x, base_y-40);
            getWorld().addObject(new ground(4, true), x, base_y-60);
            getWorld().addObject(new ground(4, true), x, base_y-80);
            getWorld().addObject(new ground(4, true), x, base_y-100);
            getWorld().addObject(new ground(4, true), x-20, base_y-60);
            getWorld().addObject(new ground(4, true), x+20, base_y-60);
            getWorld().addObject(new ground(4, true), x-20, base_y-80);
            getWorld().addObject(new ground(4, true), x+20, base_y-80); break;

            case 4:
            getWorld().addObject(new ground(3, true), x, base_y-20);
            getWorld().addObject(new ground(3, true), x, base_y-40);
            getWorld().addObject(new ground(4, true), x, base_y-60);
            getWorld().addObject(new ground(4, true), x, base_y-80);
            getWorld().addObject(new ground(4, true), x, base_y-100);
            getWorld().addObject(new ground(4, true), x-20, base_y-60);
            getWorld().addObject(new ground(4, true), x+20, base_y-60);
            getWorld().addObject(new ground(4, true), x-20, base_y-80);
            getWorld().addObject(new ground(4, true), x+20, base_y-80); break;

            case 5:
            getWorld().addObject(new ground(3, true), x, base_y-20);
            getWorld().addObject(new ground(3, true), x, base_y-40);
            getWorld().addObject(new ground(4, true), x, base_y-60);
            getWorld().addObject(new ground(4, true), x, base_y-80);
            getWorld().addObject(new ground(4, true), x, base_y-100);
            getWorld().addObject(new ground(4, true), x-20, base_y-60);
            getWorld().addObject(new ground(4, true), x+20, base_y-60);
            getWorld().addObject(new ground(4, true), x-20, base_y-80);
            getWorld().addObject(new ground(4, true), x+20, base_y-80); break;

            case 1:
            getWorld().addObject(new ground(3, false), x, base_y-20);
            getWorld().addObject(new ground(3, false), x, base_y-40);
            getWorld().addObject(new ground(4, false), x, base_y-60);
            getWorld().addObject(new ground(4, false), x, base_y-80);
            getWorld().addObject(new ground(4, false), x, base_y-100);
            getWorld().addObject(new ground(4, false), x-20, base_y-60);
            getWorld().addObject(new ground(4, false), x+20, base_y-60);
            getWorld().addObject(new ground(4, false), x-20, base_y-80);
            getWorld().addObject(new ground(4, false), x+20, base_y-80); break;

            case 2:
            getWorld().addObject(new ground(3, false), x, base_y-20);
            getWorld().addObject(new ground(3, false), x, base_y-40);
            getWorld().addObject(new ground(3, false), x, base_y-60);
            getWorld().addObject(new ground(3, false), x, base_y-80);
            getWorld().addObject(new ground(4, false), x, base_y-100);
            getWorld().addObject(new ground(4, false), x, base_y-120);
            getWorld().addObject(new ground(4, false), x, base_y-140);
            getWorld().addObject(new ground(4, false), x-20, base_y-100);
            getWorld().addObject(new ground(4, false), x+20, base_y-100);
            getWorld().addObject(new ground(4, false), x-40, base_y-100);
            getWorld().addObject(new ground(4, false), x+40, base_y-100);
            getWorld().addObject(new ground(4, false), x-20, base_y-120);
            getWorld().addObject(new ground(4, false), x+20, base_y-120); break;

            case 3:
            getWorld().addObject(new ground(3, true), x, base_y-20);
            getWorld().addObject(new ground(3, true), x, base_y-40);
            getWorld().addObject(new ground(3, true), x, base_y-60);
            getWorld().addObject(new ground(3, true), x, base_y-80);
            getWorld().addObject(new ground(4, true), x, base_y-100);
            getWorld().addObject(new ground(4, true), x, base_y-120);
            getWorld().addObject(new ground(4, true), x, base_y-140);
            getWorld().addObject(new ground(4, true), x-20, base_y-100);
            getWorld().addObject(new ground(4, true), x+20, base_y-100);
            getWorld().addObject(new ground(4, true), x-40, base_y-100);
            getWorld().addObject(new ground(4, true), x+40, base_y-100);
            getWorld().addObject(new ground(4, true), x-20, base_y-120);
            getWorld().addObject(new ground(4, true), x+20, base_y-120); break;

            case 6:
            getWorld().addObject(new ground(3, true), x, base_y-20);
            getWorld().addObject(new ground(3, true), x, base_y-40);
            getWorld().addObject(new ground(3, true), x, base_y-60);
            getWorld().addObject(new ground(3, true), x, base_y-80);
            getWorld().addObject(new ground(4, true), x, base_y-100);
            getWorld().addObject(new ground(4, true), x, base_y-120);
            getWorld().addObject(new ground(4, true), x, base_y-140);
            getWorld().addObject(new ground(4, true), x-20, base_y-100);
            getWorld().addObject(new ground(4, true), x+20, base_y-100);
            getWorld().addObject(new ground(4, true), x-40, base_y-100);
            getWorld().addObject(new ground(4, true), x+40, base_y-100);
            getWorld().addObject(new ground(4, true), x-20, base_y-120);
            getWorld().addObject(new ground(4, true), x+20, base_y-120); break;

            case 7:
            getWorld().addObject(new ground(3, true), x, base_y-20);
            getWorld().addObject(new ground(3, true), x, base_y-40);
            getWorld().addObject(new ground(3, true), x, base_y-60);
            getWorld().addObject(new ground(3, true), x, base_y-80);
            getWorld().addObject(new ground(4, true), x, base_y-100);
            getWorld().addObject(new ground(4, true), x, base_y-120);
            getWorld().addObject(new ground(4, true), x, base_y-140);
            getWorld().addObject(new ground(4, true), x-20, base_y-100);
            getWorld().addObject(new ground(4, true), x+20, base_y-100);
            getWorld().addObject(new ground(4, true), x-40, base_y-100);
            getWorld().addObject(new ground(4, true), x+40, base_y-100);
            getWorld().addObject(new ground(4, true), x-20, base_y-120);
            getWorld().addObject(new ground(4, true), x+20, base_y-120); break;
        }
    }
}