import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * Write a description of class actor here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class actor extends Actor
{
    static GreenfootSound[] walking = new GreenfootSound[4];
    double x, y, xs, ys;
    boolean can_jump = false;
    String place_left = "z", place_right = "c", left = "a", right = "d", up = "space", inventory = "e", menu = "escape", pending_key = "";
    int health, sound_delay, run_delay, left_taps, right_taps;
    final int jump = 3, step_delay = 30, sprint_delay = 10;
    final double speed = 1, sprint_speed = 2;

    public void ini_sounds()
    {
        if(walking[0] == null)
        {
            walking[0] = new GreenfootSound("grass1.mp3");
            walking[1] = new GreenfootSound("grass2.mp3");
            walking[2] = new GreenfootSound("grass3.mp3");
            walking[3] = new GreenfootSound("grass4.mp3");
        }
        for(int i = 0; i<4; i++) { walking[i].setVolume(30); }
    }

    public void act() 
    {
        get_input();
        add_gravity();
        if(sound_delay > 0) { sound_delay--; }
        if(run_delay > 0) { run_delay--; }
        if(xs != 0 && sound_delay <=0 && on_ground()) { walking[Greenfoot.getRandomNumber(4)].play(); sound_delay = step_delay; }
        x+=xs;
        y+=ys;
        setLocation(x, y);
    } 

    public actor()
    {
        ini_sounds();
        setImage(new GreenfootImage(20, 20));
        getImage().fill();
        getImage().setColor(Color.RED);
        getImage().fillRect(1, 1, 18, 18);
    }

    private void setLocation(double x, double y)
    {
        WORLD_LOADER.setLocation((int) x, (int) y);
        ((myWorld) getWorld()).actor_x = (int)x;
    }

    public void add_gravity()
    {
        on_top(); hit_left(); hit_right();
        if(!on_ground()) 
        {
            if(ys < ((myWorld) getWorld()).max_gravity)
            {
                ys += ((myWorld) getWorld()).gravity;
            }
        }
    }

    private void get_input()
    {        
        String key = "";
        if(Greenfoot.isKeyDown(right)) { if(pending_key != right) { pending_key = right; run_delay = sprint_delay; } }
        if(pending_key == right && !Greenfoot.isKeyDown(right)) { right_taps = 0; left_taps = 0; if(run_delay > 0) { key = right; } pending_key = ""; }

        if(Greenfoot.isKeyDown(left)) { if(pending_key != left) { pending_key = left; run_delay = sprint_delay; } }
        if(pending_key == left && !Greenfoot.isKeyDown(left)) { right_taps = 0; left_taps = 0; if(run_delay > 0) { key = left; } pending_key = ""; }
        
        if(Greenfoot.isKeyDown(inventory)) { if(pending_key != inventory) { pending_key = inventory; } }
        if(pending_key == inventory && !Greenfoot.isKeyDown(inventory)) { key = inventory; pending_key = ""; }

        if(key != "")
        {
            if(key.equals(inventory) && !((myWorld) getWorld()).showing_backpack) { ((myWorld) getWorld()).showing_backpack = true; key = ""; }
            if(key.equals(inventory) && (((myWorld) getWorld()).showing_backpack || ((myWorld) getWorld()).showing_crafting || ((myWorld) getWorld()).showing_smelting)) { ((myWorld) getWorld()).showing_backpack = false; ((myWorld) getWorld()).showing_crafting = false; ((myWorld) getWorld()).showing_smelting = false; }
            if(key.equals(right)) { right_taps = 1; key = ""; System.out.println("1 right-tap");  }
            if(key.equals(left)) { left_taps = 1; key = ""; System.out.println("1 left-tap"); }
        }

        if(run_delay <= 0 && pending_key != key && !Greenfoot.isKeyDown(pending_key)) { left_taps = 0; right_taps = 0; }

        if(Greenfoot.isKeyDown(left)) { xs = -speed; }
        if(Greenfoot.isKeyDown(right)) { xs = speed; }

        if(left_taps == 1 && pending_key == left) { xs = -sprint_speed; }
        if(right_taps ==1 && pending_key == right) { xs = sprint_speed; }

        if(!Greenfoot.isKeyDown(left) && !Greenfoot.isKeyDown(right)) { xs = 0; }

        if(Greenfoot.isKeyDown(up) && can_jump)
        {
            ys = -jump;
            y+=ys;
            can_jump = false;
        }
    }

    public boolean on_ground()
    {
        for(int i = -getImage().getWidth()/2+3; i < getImage().getWidth()/2-3; i++)
        {
            ground GROUND = (ground) getOneObjectAtOffset(i, getImage().getHeight()/2, ground.class);
            if(GROUND != null && GROUND.in_foreground)
            {
                can_jump = true; ys = 0; if((int)y%20 != 0) { y = y-y%20; setLocation(x, y); }  return true;
            }
        }
        can_jump = false;
        return false;
    }   

    public void on_top()
    {
        for(int i = -getImage().getWidth()/2+3; i < getImage().getWidth()/2-3; i++)
        {
            ground GROUND = (ground) getOneObjectAtOffset(i, -getImage().getHeight()/2, ground.class);
            if(GROUND != null && GROUND.in_foreground) { ys = 0; y++; }
        }
        can_jump = false;
    }   

    public void hit_right()
    {
        for(int i = -getImage().getHeight()/2+4; i < getImage().getHeight()/2-4; i++)
        {
            ground GROUND = (ground) getOneObjectAtOffset(getImage().getWidth()/2, i, ground.class);
            if(GROUND != null && GROUND.in_foreground)
            {
                if(!Greenfoot.isKeyDown(left)) { xs = 0; }
                if((int)x%20 != 0) { x = x-x%20; setLocation(x-1, y); } 
            }
        }
    }   

    public void hit_left()
    {
        for(int i = -getImage().getHeight()/2+4; i < getImage().getHeight()/2-4; i++)
        {
            ground GROUND = (ground) getOneObjectAtOffset(-getImage().getWidth()/2, i, ground.class);
            if(GROUND != null && GROUND.in_foreground)
            {
                if(!Greenfoot.isKeyDown(right)) { xs = 0; }
                if(x < 0) { if((int)x%20 != 0) { x = x-x%20; setLocation(x+1, y); } }
                else { if((int)x%20 != 0) { x = x-x%20+20; setLocation(x+1, y); } }
            }
        }
    }

    //     int hash32shift(int key)
    //     {
    //         key = ~key + (key << 15); // key = (key << 15) - key - 1;
    //         key = key ^ (key >>> 12);
    //         key = key + (key << 2);
    //         key = key ^ (key >>> 4);
    //         key = key * 2057; // key = (key + (key << 3)) + (key << 11);
    //         key = key ^ (key >>> 16);
    //         return key;
    //     }
    // 
    //     int noise(int x, int y, int seed)
    //     {
    //         return hash32shift(seed+hash32shift(x+hash32shift(y)));
    //     }

}
